
package require -exact snack 2.1
# Try to load optional file format handler
catch { package require snackogg }
namespace eval snackServer {
   variable servsock
   variable msg
   variable port 23654
}
###########################################################################
# Code to respond to remote requests and play the file
###########################################################################

snack::debug 0


proc snackServer::Cmd {sock addr port} {
   variable servsock
   variable msg

   set cmd [read $sock 4]
   switch $cmd {
      play {
         set s [snack::sound -debug 5 -frequency 16000 -encoding lin16 -byteorder big]
         puts $sock $s ;# return token for this job
         flush $sock
         $s configure -channel $sock;# -guessproperties yes
         puts play
         $s play -command "[list close $sock]; set msg idle;$s destroy"
         puts played
         set msg playing
      }
      stop {
         set handle [gets $sock] ;# get token (sound name) and stop playback
         catch { $handle stop }
         catch { $handle destroy }
         close $sock
         set msg idle
      }
      pause {
         set handle [gets $sock] ;# get token (sound name) and stop playback
         catch { $handle pause }
         set msg idle
      }
      seek {
         set command [gets $sock] ;# get token (sound name) and stop playback
         foreach {handle position} $command {break}
         ;# Play at some offset
         set msg playing
      }
      exit {
         close $sock
         close $servsock
         exit
      }
      default {
         puts "Unknown command"
      }
   }
}

set snackServer::servsock [socket -server snackServer::Cmd $snackServer::port]

# Make sure the server socket always is closed properly on exit

wm protocol . WM_DELETE_WINDOW {close $snackServer::servsock; exit}
;##
;# Command to clear then create a new port
;#
proc snackServer::NewPort {} {
   variable servsock
   variable port
   close $servsock
   set servsock [socket -server snackServer::Cmd $port]
}

###########################################################################
# Code to control the remote playing
###########################################################################
namespace eval snackControl {
}

                                  #host1:port
proc snackControl::PlayFile {file hostport} {
   # Open the sound file as a binary file

   if [catch {set fd [open $file]} res] {
      puts $res
      exit
   }
   fconfigure $fd -translation binary
   if {$::tcl_version > 8.0} {
      fconfigure $fd -encoding binary
   }

   # Quick way to set both host and port

   foreach {host port} [split $hostport :] break

   # Open binary socket connection to aserver.tcl

   if [catch {set sock [socket $host $port]} res] {
      puts "Error: no aserver.tcl at $host,$port"
      return
   }
   fconfigure $sock -translation binary -blocking 1
   if {$::tcl_version > 8.0} {
      fconfigure $sock -encoding binary
   }

   # Notify the server that a play operation is due

   puts -nonewline $sock play
   flush $sock

   # Get handle for this operation from the server.
   # Can be used to stop the operation later. (Not shown here.)

   set handle [gets $sock]

   # Write audio data as long as the server can accept more

   fileevent $sock writable [list snackControl::PlayHandler $fd $sock]
}

proc snackControl::PlayHandler {fd sock} {
   set data [read $fd 10000]
   puts -nonewline $sock $data
   if [eof $fd] {
      close $fd
      close $sock
      exit
   }
}


