namespace eval streamout {
   variable servsock {}
   variable mimetype
   array set mimetype {
      1  "Content-type: audio/mp3\n"
      2  "Content-type: audio/mpeg\n"
      3  "Content-type: audio/x-mp3\n"
      4  "Content-type: audio/x-mpeg\n"
      5  "Content-type: audio/m3u\n"
      6  "Content-type: audio/x-m3u\n"
   }

}
;##
;# When client connects, immediatly send tracks to it.
;#
proc streamout::connect {sock addr port} {
   Trace
   nexttrack $sock
}
;##
;# Send a new track to a socket
;#
proc streamout::nexttrack {sock} {
   Trace
   set fileName [soundControl::fileName]  ;# expand
   set in [open $fileName r]
   fconfigure $in -translation binary
   fconfigure $sock -translation binary
   #puts -nonewline $sock [header $fileName]

   #HttpD::queueCloseFile $sock $in $tfile
   fcopy $in $sock -command [list streamout::copydone $in $sock]
}
###############################################################################
# Function   : streamout::header
# Description:
# Author     : Tom Wilkason
# Date       : 3/5/2003
###############################################################################
proc streamout::header {file} {
   Trace
   variable mimetype
   append result "HTTP/1.0 200 Data follows\n"
   append result $mimetype(2)
   #append result "Connection Close:\n"
   append result "Connection: Keep-Alive\n"
   append result "Content-Length: [file size $file]\n\n"
   return $result
}
;##
;# Track has been sent, close the file and send the next one
;#
proc streamout::copydone {in sock args} {
   Trace
   close $in
   #after idle [list nexttrack $sock]
}
;##
;# Establish streaming server
;#
proc streamout::newport {{port 8181}} {
   Trace
   variable servsock
   variable streamPort $port
   catch {close $servsock}
   set servsock [socket -server streamout::connect $streamPort]
   fconfigure $servsock -translation binary -blocking 0
   if {$::tcl_version > 8.0} {
      fconfigure $servsock -encoding binary
   }
   puts "Established socket $servsock on port $streamPort"
}
streamout::newport

